var labels = document.getElementsByClassName("dr_label");

var errors = [];
for(var i = 0; undefined != labels && i < labels.length; i++) {
    drErrors = labels[i].getElementsByClassName("dr_error");
    for(var j = 0; undefined != drErrors && j < drErrors.length; j++) {
        var error = drErrors[j];
        if(null != error) {
            error = error.innerHTML;
            if(error.length == 0) error = null;
        }
        var lbl = {
            label: labels[i].htmlFor,
            error: error
        };

        if(null != error) {
            errors.push(lbl);
        }
    }
}

var formLines = document.getElementsByClassName("dr_formLine");
if(undefined != formLines && formLines.length > 0) {
    drErrors = formLines[0].getElementsByClassName("dr_error");
    for(var j = 0; undefined != drErrors && j < drErrors.length; j++) {
        var generalError = drErrors[j];
        if(undefined != generalError) {
            errors.push({label: "general", error: generalError.innerText});
        }
    }
}

var serverError = document.getElementById("dr_ServerError");
if(undefined != serverError) {
    drErrors = serverError.getElementsByClassName("dr_error");
    for(var j = 0; undefined != drErrors && j < drErrors.length; j++) {
        var generalError = drErrors[j];
        if(undefined != generalError) {
            errors.push({label: "serverError", error: generalError.innerText});
        }
    }
}

function findRequestId(element) {
    for(var i = 0; i < element.childNodes.length; i++) {
        var node = element.childNodes[i];
        if(undefined != node && node.nodeType === 8 && node.nodeValue != undefined) {
            index = node.nodeValue.indexOf("REQUEST ID: ");
            if(index > 0) {
                return node.nodeValue.substring(index + 12, node.nodeValue.length).trim();
            }
        }
    }
    return "";
}

requestId = findRequestId(document.getElementsByTagName('head')[0]);

try {
    WebView.onJsCallback(JSON.stringify({ 
		command: "drerrors",
		tag: "$tag",
		requestID: requestId,
		errors: errors}));
} catch (error) {
    console.error("Unable to find marshaling object (WebView)");
    console.error(error);
}
